/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of TinyCDB.xs. Do not edit this file, edit TinyCDB.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "TinyCDB.xs"

#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "cdb.h"

#ifdef __cplusplus
}
#endif

/* alias */
#define DOOPEN          1
#define DOCREATE        2
#define DOUPDATE        4
#define DOLOAD          8
#define WITHTEMP        (DOCREATE | DOUPDATE)
#define WITHOPEN        (DOOPEN | DOUPDATE | DOLOAD)
#define READONLY        (DOOPEN | DOLOAD)

/* opts */
#define EACH_INITIALIZED 1
#define COMMITTED       2
#define DIED            4

/* get mode */
#define DOGETALL        1
#define DOGETLAST       2

/* methods */
#define METHOD_GET      1
#define METHOD_GETALL   2
#define METHOD_KEYS     4
#define METHOD_EACH     8
#define METHOD_ADD      16
#define METHOD_INSERT   32
#define METHOD_EXISTS   64
#define METHOD_FINISH   128


/* <cdb_make_free is not public - copy from cdb_ini.h and cdb_make.c> */
struct cdb_rec {
  unsigned hval;
  unsigned rpos;
};

struct cdb_rl {
  struct cdb_rl *next;
  unsigned cnt;
  struct cdb_rec rec[254];
};
static void
cdb_make_free(struct cdb_make *cdbmp)
{
  unsigned t;
  for(t = 0; t < 256; ++t) {
    struct cdb_rl *rl = cdbmp->cdb_rec[t];
    while(rl) {
      struct cdb_rl *tm = rl;
      rl = rl->next;
      free(tm);
    }
  }
}
/* </cdb_make_free is not public - copy from cdb_int.h and cdb_make.c> */

#define GROWIFNEEDED(self, var, len, bufsize) if (len > bufsize) { \
                                                Renew(var, len + 1, char); \
                                                if ( var == NULL ) { \
                                                     memerror(self, len + 1); \
                                                }; \
                                                bufsize = len; \
                                              };

#define MAKESV(var, len)    SV *var = sv_newmortal(); \
                            SvUPGRADE( var, SVt_PV ); \
                            (void)SvPOK_only( var ); \
                            SvGROW( var, len + 1 ); \
                            SvCUR_set( var, len );

#define PUSHWITHNULL(var,len)   SvPV(var, PL_na)[len] = '\0'; \
                                XPUSHs( var );

#define ALREADY_COMMITTED croak("Database changes already committed")
#define READ_ONLY_MODE croak("Database opened in read only mode")
#define FATAL_ERROR croak("Database unstable - cannot continue")
#define CREATE_ONLY_MODE croak("Database opened in create only mode")

struct t_cdb {
    char *fn;     /* file name */
    char *fntemp;    /* tempfile name */
    PerlIO *fd;   /* file descriptor */
    PerlIO *fdtemp;    /* tempfile descriptor */
    struct cdb cdb;    /* cdb struct */
    struct cdb_make cdbm;    /* cdb_make struct */
    int alias;    /* summoned to do */
    int opts;    /* options */
    unsigned int curpos;    /* current position in file */
    int dend;    /* end position in file */
    struct {     /* container for allocated memory */
        unsigned char *buf;
        char *key;
        char *val;
    } mem;
};

typedef struct t_cdb CDB_TinyCDB;

static void memfree ( CDB_TinyCDB * self ) {
    if ( self->mem.buf ) { Safefree(self->mem.buf); self->mem.buf = 0; }
    if ( self->mem.key ) { Safefree(self->mem.key); self->mem.key = 0; }
    if ( self->mem.val ) { Safefree(self->mem.val); self->mem.val = 0; }
}
static void fileerror(CDB_TinyCDB * self, char *op, char *fn) {
    memfree(self);
    self->opts |= DIED;
    croak("Unable to %s file %s: %s", op, fn, Strerror(errno));
}
static void memerror(CDB_TinyCDB * self, const int size) {
    memfree(self);
    self->opts |= DIED;
    croak("Unable to allocate %d bytes of memory", size);
}

static void assert_status(CDB_TinyCDB * self, const int method) {
    if ( self->opts & DIED ) FATAL_ERROR;
    switch (method) {
        case METHOD_GET:
        case METHOD_GETALL:
        case METHOD_KEYS:
        case METHOD_EACH:
            if (self->alias == DOCREATE) {
                CREATE_ONLY_MODE;
            }
            break;
        case METHOD_ADD:
        case METHOD_INSERT:
            if ( self->alias & WITHTEMP ) {
                if ( self->opts & COMMITTED ) {
                    ALREADY_COMMITTED;
                }
            } else {
                READ_ONLY_MODE;
            } 
            break;
        case METHOD_FINISH:
            if ( ! ( self->alias & WITHTEMP ) ) {
                READ_ONLY_MODE;
            }
            break;
        case METHOD_EXISTS:
            if (self->alias == DOCREATE && self->opts & COMMITTED) {
                ALREADY_COMMITTED;
            }
            break;
    }
}

static void commit( CDB_TinyCDB * self, const int save_changes, const int reopen ) {
    if (self->opts & COMMITTED) return;
    self->opts |= COMMITTED;

    if ( self->alias & WITHOPEN ) {
        if (self->alias & DOLOAD) {
            cdb_free(&self->cdb);
        }
        if ( PerlIO_error( self->fd ) ) {
            fileerror(self, "close", self->fn);
        }
        PerlIO_close(self->fd);
    }
    if ( self->alias & WITHTEMP ) {
        if ( save_changes ) {
            if ( cdb_make_finish(&self->cdbm) != 0 ) {
                fileerror(self, "commit changes", self->fntemp);
            };
        } else {
            cdb_make_free(&self->cdbm);
        };
        if ( PerlIO_close(self->fdtemp) != 0 ) {
            fileerror(self, "close", self->fntemp);
        };

        if ( save_changes ) {
            if ( rename(self->fntemp, self->fn) != 0 ) {
                fileerror(self, "replace", self->fn);
            };

            if ( reopen  && ! (self->alias == DOCREATE)) {
                self->fd = PerlIO_open(self->fn, "rb");
                if ( ! self->fd ) {
                    fileerror(self, "reopen", self->fn);
                }
                if (self->alias & DOLOAD) { /* mmap to memory whole file */
                    cdb_init(&self->cdb, PerlIO_fileno( self->fd ));
                }
            }
        } else {
            if ( unlink(self->fntemp) != 0 ) {
                fileerror(self, "unlink", self->fntemp);
            };
        }
    };
}

static int perlio_bread(PerlIO *fd, void *buf, int len) {
    int l;
    while (len > 0) {
        do {
            l = PerlIO_read(fd, buf, len);
        } while (l < 0 && errno == EINTR);

        if (l <= 0) {
            if (!l) {
                errno = EIO;
            }
            return -1;
        }
        buf = (char*)buf + l;
        len -= l;
    }
    return 0;
}

#line 241 "TinyCDB.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 385 "TinyCDB.c"

XS_EUPXS(XS_CDB__TinyCDB_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_open)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "CLASS, ...");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	CDB_TinyCDB *	RETVAL;
#line 241 "TinyCDB.xs"
        if ( sv_isobject( ST(0) ) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
            croak("%s is already blessed\n", SvPV(ST(0), PL_na));
        }
#line 402 "TinyCDB.c"
#line 245 "TinyCDB.xs"
    {
        int mode = 0;
        if ( items == 4) {
            char *for_method = SvPV( ST(2), PL_na);
            if ( strEQ(for_method, "for_update") ) {
                mode |= DOUPDATE;
            } else {
                croak("Invalid mode %s", for_method);
            }
        } else if ( items != 2 ) {
            croak("Invalid numbers of arguments");
        }

        Newx(RETVAL, 1, CDB_TinyCDB);

        RETVAL->alias = mode | ( ix ? ix : DOOPEN );

        RETVAL->fn = savepv( SvPV( ST(1), PL_na ) );
        RETVAL->fntemp = 0;
        RETVAL->curpos = 0;
        RETVAL->opts = 0;
        RETVAL->mem.buf = 0;
        RETVAL->mem.key = 0;
        RETVAL->mem.val = 0;

        if ( RETVAL->alias & WITHOPEN ) {
            RETVAL->fd = PerlIO_open(RETVAL->fn, "rb");
            if ( ! RETVAL->fd ) {
                fileerror(RETVAL, "open", RETVAL->fn);
            }
            if (RETVAL->alias & DOLOAD) { 
                cdb_init(&RETVAL->cdb, PerlIO_fileno( RETVAL->fd ));
            }
        }
        if (RETVAL->alias & WITHTEMP) { 
            RETVAL->fntemp = savepv( SvPV( ST(3), PL_na ) );
            RETVAL->fdtemp = PerlIO_open(RETVAL->fntemp, "w+b");

            if ( ! RETVAL->fdtemp ) {
                fileerror(RETVAL, "create", RETVAL->fn);
            };
            cdb_make_start(&RETVAL->cdbm, PerlIO_fileno( RETVAL->fdtemp ));

            unsigned int kbufsize = 2048, vbufsize = 2048;
            unsigned int klen = 0, vlen = 0, curpos = 0;


            Newx(RETVAL->mem.key, kbufsize + 1, char);
            Newx(RETVAL->mem.val, vbufsize + 1, char);

            if (RETVAL->alias & DOUPDATE) {

                if (RETVAL->alias & DOLOAD) { 

                    cdb_seqinit( &curpos, &RETVAL->cdb );
                    while ( cdb_seqnext(&curpos, &RETVAL->cdb) > 0 ) {
                        klen = cdb_keylen( &RETVAL->cdb );
                        vlen = cdb_datalen( &RETVAL->cdb );

                        GROWIFNEEDED( RETVAL, RETVAL->mem.key, klen, kbufsize );
                        GROWIFNEEDED( RETVAL, RETVAL->mem.val, vlen, vbufsize );

                        cdb_read( &RETVAL->cdb, RETVAL->mem.key, klen, cdb_keypos(&RETVAL->cdb) );
                        cdb_read( &RETVAL->cdb, RETVAL->mem.val, vlen, cdb_datapos(&RETVAL->cdb) );

                        if ( cdb_make_add(&RETVAL->cdbm,
                                RETVAL->mem.key, klen,
                                RETVAL->mem.val, vlen
                            ) < 0
                        ) {
                            fileerror(RETVAL, "update", RETVAL->fntemp);
                        }
                    }
                } else { 
                    unsigned int bytes, dend;

                    Newx(RETVAL->mem.buf, 2048, unsigned char); 

                    PerlIO_rewind( RETVAL->fd );
                    bytes = PerlIO_read( RETVAL->fd, RETVAL->mem.buf, 2048 );

                    if ( bytes == 2048 ) {
                        dend = cdb_unpack(RETVAL->mem.buf);
                        curpos += bytes;

                        while ( curpos < dend - 8) {
                            bytes = PerlIO_read( RETVAL->fd, RETVAL->mem.buf, 8 );
                            if ( bytes != 8 ) {
                                fileerror(RETVAL, "read", RETVAL->fn);
                            }
                            curpos += bytes;

                            klen = cdb_unpack(RETVAL->mem.buf);
                            vlen = cdb_unpack(RETVAL->mem.buf + 4);

                            if (dend - klen < curpos || dend - vlen < curpos + klen) {
                                fileerror(RETVAL, "read", RETVAL->fn);
                            }

                            GROWIFNEEDED( RETVAL, RETVAL->mem.key, klen, kbufsize );

                            bytes = PerlIO_read( RETVAL->fd, RETVAL->mem.key, klen );
                            if (bytes != klen) {
                                fileerror(RETVAL, "read", RETVAL->fn);
                            };
                            curpos += bytes;

                            GROWIFNEEDED( RETVAL, RETVAL->mem.val, vlen, vbufsize );

                            bytes = PerlIO_read( RETVAL->fd, RETVAL->mem.val, vlen );
                            if (bytes != vlen) {
                                fileerror(RETVAL, "read", RETVAL->fn);
                            };
                            curpos += bytes;

                            if ( cdb_make_add(&RETVAL->cdbm,
                                    RETVAL->mem.key, klen,
                                    RETVAL->mem.val, vlen
                                ) < 0
                            ) {
                                fileerror(RETVAL, "update", RETVAL->fntemp);
                            }
                        };
                    } else {
                        fileerror(RETVAL, "read", RETVAL->fn);
                    }
                    PerlIO_rewind( RETVAL->fd );
                    if ( PerlIO_error( RETVAL->fd ) )
                        fileerror(RETVAL, "set position", RETVAL->fn);
                }
            }

        }
        memfree( RETVAL );
    }
#line 539 "TinyCDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    SvREADONLY_on( SvRV( RETVALSV ) );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CDB__TinyCDB_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_create)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "CLASS, fn, fntemp");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	fn = (char *)SvPV_nolen(ST(1))
;
	char *	fntemp = (char *)SvPV_nolen(ST(2))
;
	CDB_TinyCDB *	RETVAL;
#line 389 "TinyCDB.xs"
        if ( sv_isobject( ST(0) ) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG )) {
            croak("%s is already blessed\n", SvPV(ST(0), PL_na));
        }
#line 570 "TinyCDB.c"
#line 393 "TinyCDB.xs"
    {
        Newx(RETVAL, 1, CDB_TinyCDB);

        RETVAL->alias = DOCREATE;

        RETVAL->fn = savepv( fn );
        RETVAL->fntemp = savepv( fntemp );
        RETVAL->curpos = 0;
        RETVAL->opts = 0;
        RETVAL->mem.buf = 0;
        RETVAL->mem.key = 0;
        RETVAL->mem.val = 0;

        RETVAL->fdtemp = PerlIO_open(fntemp, "w+b");

        if ( ! RETVAL->fdtemp ) {
            fileerror(RETVAL, "create", fn);
        };
        cdb_make_start(&RETVAL->cdbm, PerlIO_fileno( RETVAL->fdtemp ));
    }
#line 592 "TinyCDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    SvREADONLY_on( SvRV( RETVALSV ) );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CDB__TinyCDB_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	CDB_TinyCDB *	self;
	char *	key = (char *)SvPV_nolen(ST(1))
;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::get() -- self is not a blessed SV reference" )
;
#line 422 "TinyCDB.xs"
        assert_status( self, METHOD_GET );
#line 631 "TinyCDB.c"
#line 424 "TinyCDB.xs"
    {
        unsigned int vlen = 0;
        STRLEN klen = strlen(key);

        if (self->alias & DOLOAD) { /* tinyfile whole in memory */
            if (cdb_find(&self->cdb, key, klen) > 0) {
                vlen = cdb_datalen( &self->cdb ); /* length of data */

                MAKESV( val, vlen );
                if ( cdb_read( &self->cdb, SvPVX(val), vlen, cdb_datapos( &self->cdb )) < 0 ) {
                    fileerror(self, "read", self->fn);
                };
                PUSHWITHNULL( val, vlen );
            };
        } else {
            if ( cdb_seek(PerlIO_fileno(self->fd), key, klen, &vlen) > 0 ) {
                MAKESV( val, vlen );
                if ( cdb_bread( PerlIO_fileno(self->fd), SvPVX(val), vlen ) < 0)  {
                    fileerror(self, "read", self->fn);
                };
                XPUSHs( sv_2mortal(newSVpvn(self->mem.val, vlen)) );
                PUSHWITHNULL( val, vlen );
            };
        };
    }
#line 658 "TinyCDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_CDB__TinyCDB_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_exists)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    {
	CDB_TinyCDB *	self;
	char *	key = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::exists() -- self is not a blessed SV reference" )
;
#line 455 "TinyCDB.xs"
        assert_status( self, METHOD_EXISTS );
#line 691 "TinyCDB.c"
#line 457 "TinyCDB.xs"
    {
        STRLEN klen = strlen(key);

        if (self->alias & WITHTEMP && !( self->opts & COMMITTED)) { /* for_create | for_update | create */
            RETVAL = cdb_make_exists(&self->cdbm, key, klen);
            if ( RETVAL < 0 ) {
                fileerror(self, "read", self->fntemp);
            }
        } else {
            if (self->alias & DOLOAD) { /* tinyfile whole in memory */
                RETVAL = cdb_find(&self->cdb, key, klen);
            } else {
                unsigned int vlen;
                RETVAL = cdb_seek(PerlIO_fileno(self->fd), key, klen, &vlen);
            };

            if ( RETVAL < 0 ) {
                fileerror(self, "read", self->fn);
            }
        }
    }
#line 714 "TinyCDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CDB__TinyCDB_getall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_getall)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	CDB_TinyCDB *	self;
	char *	key = (char *)SvPV_nolen(ST(1))
;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::getall() -- self is not a blessed SV reference" )
;
#line 489 "TinyCDB.xs"
        assert_status( self, METHOD_GETALL );
#line 748 "TinyCDB.c"
#line 491 "TinyCDB.xs"
    {
        unsigned int kbufsize = 2048;
        unsigned int klen = 0, vlen = 0;
        unsigned int lastpos = 0, lastvlen = 0;
        STRLEN searchklen = strlen(key);

        int mode = ix ? ix : DOGETALL;

        if (self->alias & DOLOAD) { /* tinyfile whole in memory */
            struct cdb_find cdbf;

            cdb_findinit( &cdbf, &self->cdb, key, searchklen );
            while ( cdb_findnext(&cdbf) > 0 ) {
                vlen = cdb_datalen(&self->cdb); /* length of data */
                lastpos = cdb_datapos(&self->cdb);

                if ( mode == DOGETALL ) {
                    MAKESV( val, vlen );

                    if (cdb_read(&self->cdb, SvPVX(val), vlen, lastpos) < 0 ) {
                        fileerror(self, "read", self->fn);
                    }

                    PUSHWITHNULL( val, vlen );
                }
            }
            if ( mode == DOGETLAST && lastpos ) {
                MAKESV( val, vlen );
                if (cdb_read(&self->cdb, SvPVX(val), vlen, lastpos) < 0 ) {
                    fileerror(self, "read", self->fn);
                }
                PUSHWITHNULL( val, vlen );
            }
        } else { /* open */
            unsigned int bytes, dend, curpos = 0;
            Off_t prevpos = PerlIO_tell( self->fd );

            Newx(self->mem.buf, kbufsize + 1, unsigned char); /* allocate memory */
            Newx(self->mem.key, kbufsize + 1, char); /* allocate memory */

            PerlIO_rewind( self->fd );
            bytes = PerlIO_read( self->fd, self->mem.buf, 2048 );

            if ( bytes == 2048 ) {
                dend = cdb_unpack(self->mem.buf);
                curpos += bytes;

                while ( curpos < dend - 8) {
                    bytes = PerlIO_read( self->fd, self->mem.buf, 8 );
                    if ( bytes != 8 )
                        fileerror(self, "read", self->fn);
                    curpos += bytes;

                    klen = cdb_unpack(self->mem.buf);
                    vlen = cdb_unpack(self->mem.buf + 4);

                    if (dend - klen < curpos || dend - vlen < curpos + klen)
                        fileerror(self, "read", self->fn);

                    GROWIFNEEDED( self, self->mem.key, klen, kbufsize );

                    bytes = PerlIO_read( self->fd, self->mem.key, klen );
                    if (bytes != klen) {
                        fileerror(self, "read", self->fn);
                    };
                    curpos += bytes;
                    self->mem.key[klen] = '\0';

                    if ( klen == searchklen
                        && strnEQ( self->mem.key, key, klen )
                    ) {
                        lastpos = curpos;
                        lastvlen = vlen;

                        if ( mode == DOGETALL ) {
                            MAKESV( val, vlen );
                            if ( perlio_bread( self->fd, SvPVX(val), vlen ) < 0)  {
                                fileerror(self, "read", self->fn);
                            };
                            PUSHWITHNULL( val, vlen );
                        } else {
                            PerlIO_seek(self->fd, vlen, SEEK_CUR);
                        }
                    } else {
                        PerlIO_seek(self->fd, vlen, SEEK_CUR);
                    }
                    curpos += vlen;
                };
            } else {
                fileerror(self, "read", self->fn);
            }

            if ( mode == DOGETLAST && lastpos ) {
                PerlIO_seek( self->fd, lastpos, SEEK_SET );
                MAKESV( val, lastvlen );
                if ( perlio_bread( self->fd, SvPVX(val), lastvlen ) < 0)  {
                    fileerror(self, "read", self->fn);
                };
                PUSHWITHNULL( val, lastvlen );
            }

            /* go back to original position in file */
            PerlIO_seek( self->fd, prevpos, SEEK_SET );
            if ( PerlIO_error( self->fd ) )
                fileerror(self, "set position", self->fn);
        }
        memfree( self );
    }
#line 858 "TinyCDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_CDB__TinyCDB_each); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_each)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	CDB_TinyCDB *	self;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::each() -- self is not a blessed SV reference" )
;
#line 604 "TinyCDB.xs"
        assert_status( self, METHOD_EACH );
#line 889 "TinyCDB.c"
#line 606 "TinyCDB.xs"
    {
        unsigned int klen = 0, vlen = 0;
        unsigned int kbufsize = 2048;
        int keep_looping = 1;

        if ( self->alias & DOLOAD ) { /* load */
            if ( !( self->opts & EACH_INITIALIZED ) ) {
                self->curpos = 0;
                cdb_seqinit( &self->curpos, &self->cdb );
                self->opts |= EACH_INITIALIZED;
            }
            while ( keep_looping-- ) {
                if ( cdb_seqnext(&self->curpos, &self->cdb) > 0 ) {
                    klen = cdb_keylen( &self->cdb );
                    vlen = cdb_datalen( &self->cdb );

                    if ( klen ) {
                        MAKESV( key, klen );
                        cdb_read( &self->cdb, SvPVX(key), klen, cdb_keypos(&self->cdb) );
                        PUSHWITHNULL( key, klen );

                        MAKESV( val, vlen );
                        cdb_read( &self->cdb, SvPVX(val), vlen, cdb_datapos(&self->cdb) );
                        PUSHWITHNULL( val, vlen );
                    } else {
                        keep_looping++;
                    }
                } else {
                    self->opts &= ~EACH_INITIALIZED;
                }
            }
        } else { /* open */
            unsigned int bytes;
            unsigned int klen, vlen;
            Newx(self->mem.buf, kbufsize + 1, unsigned char); /* allocate memory */

            if ( !( self->opts & EACH_INITIALIZED ) ) {
                self->curpos = 0;
                PerlIO_rewind( self->fd );
                self->opts |= EACH_INITIALIZED;
                bytes = PerlIO_read( self->fd, self->mem.buf, 2048 );
                if ( bytes == 2048 ) {
                    self->dend = cdb_unpack(self->mem.buf);
                } else {
                    fileerror(self, "read", self->fn);
                }
                self->curpos += bytes;
            }

            while ( keep_looping-- ) {
                if ( self->curpos < self->dend - 8) {
                    bytes = PerlIO_read( self->fd, self->mem.buf, 8 );
                    if ( bytes != 8 ) {
                        fileerror(self, "read", self->fn);
                    }
                    self->curpos += bytes;

                    klen = cdb_unpack(self->mem.buf);
                    vlen = cdb_unpack(self->mem.buf + 4);

                    if (self->dend - klen < self->curpos || self->dend - vlen < self->curpos + klen)
                        fileerror(self, "read", self->fn);

                    if ( klen ) {
                        MAKESV( key, klen );
                        if ( perlio_bread( self->fd, SvPVX(key), klen ) < 0)  {
                            fileerror(self, "read", self->fn);
                        };
                        self->curpos += klen;

                        PUSHWITHNULL( key, klen );

                        MAKESV( val, vlen );
                        if ( perlio_bread( self->fd, SvPVX(val), vlen ) < 0)  {
                            fileerror(self, "read", self->fn);
                        };
                        self->curpos += vlen;

                        PUSHWITHNULL( val, vlen );
                    } else {
                        /* skip nulled out records (from replace0) */
                        self->curpos += klen + vlen;
                        PerlIO_seek(self->fd, klen + vlen, SEEK_CUR);
                        keep_looping++;
                    }
                } else {
                    self->opts &= ~EACH_INITIALIZED;
                };
            }
            if ( PerlIO_error( self->fd ) )
                fileerror(self, "close", self->fn);
        }
        memfree( self );
    }
#line 985 "TinyCDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_CDB__TinyCDB_keys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_keys)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	CDB_TinyCDB *	self;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::keys() -- self is not a blessed SV reference" )
;
#line 707 "TinyCDB.xs"
        assert_status( self, METHOD_KEYS );
#line 1016 "TinyCDB.c"
#line 709 "TinyCDB.xs"
    {
        unsigned int curpos = 0;
        unsigned int klen = 0, kbufsize = 2048;

        if ( self->alias & DOLOAD ) { /* load */

            cdb_seqinit( &curpos, &self->cdb );
            while ( cdb_seqnext(&curpos, &self->cdb) > 0 ) {
                klen = cdb_keylen( &self->cdb );

                if ( ! klen ) continue;

                MAKESV( key, klen );
                cdb_read( &self->cdb, SvPVX(key), klen, cdb_keypos(&self->cdb) );
                PUSHWITHNULL( key, klen );
            }
        } else { /* open */
            unsigned int bytes, dend;
            unsigned int klen, vlen;
            Newx(self->mem.buf, kbufsize + 1, unsigned char); /* allocate memory */

            Off_t prevpos = PerlIO_tell( self->fd );
            PerlIO_rewind( self->fd );
            bytes = PerlIO_read( self->fd, self->mem.buf, 2048 );

            if ( bytes == 2048 ) {
                dend = cdb_unpack(self->mem.buf);

                curpos += bytes;

                while ( curpos < dend - 8) {
                    bytes = PerlIO_read( self->fd, self->mem.buf, 8 );
                    if ( bytes != 8 )
                        fileerror(self, "read", self->fn);
                    curpos += bytes;

                    klen = cdb_unpack(self->mem.buf);
                    vlen = cdb_unpack(self->mem.buf + 4);

                    if (dend - klen < curpos || dend - vlen < curpos + klen)
                        fileerror(self, "read", self->fn);

                    if ( klen > 0 ) {
                        MAKESV( key, klen );
                        if ( perlio_bread( self->fd, SvPVX(key), klen ) < 0 )  {
                            fileerror(self, "read", self->fn);
                        };
                        curpos += klen;

                        PUSHWITHNULL( key, klen );
                    }
                    curpos += vlen;
                    PerlIO_seek(self->fd, vlen, SEEK_CUR);
                };
            } else {
                fileerror(self, "read", self->fn);
            }
            /* go back to original position in file */
            PerlIO_seek( self->fd, prevpos, SEEK_SET );
            if ( PerlIO_error( self->fd ) )
                fileerror(self, "set position", self->fn);
        }
        memfree( self );
    }
#line 1082 "TinyCDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_CDB__TinyCDB_put_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_put_add)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	CDB_TinyCDB *	self;
	int	RETVAL;
	dXSTARG;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::put_add() -- self is not a blessed SV reference" )
;
#line 782 "TinyCDB.xs"
        assert_status( self, METHOD_ADD );
#line 1114 "TinyCDB.c"
#line 784 "TinyCDB.xs"
    {
        char *key, *val;
        STRLEN klen, vlen;
        int mode, result, i;

        mode = ix ? ix : CDB_PUT_ADD;
        RETVAL = 0;

        for ( i = 1; i < items; i += 2 ) {
            key = SvPV( ST(i), klen );
            val = SvPV( ST(i+1), vlen );

            result = cdb_make_put(&self->cdbm, key, klen, val, vlen, mode);
            if ( result < 0 ) {
                fileerror(self, "update", self->fntemp);
            } else if ( result > 0 && mode == CDB_PUT_WARN) {
                warn("Key %s already exists - added anyway", key);
            }
            if ( mode == CDB_PUT_ADD || mode == CDB_PUT_WARN) {
                RETVAL++;
            } else {
                RETVAL += result;
            };
        };
    }
#line 1141 "TinyCDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CDB__TinyCDB_put_insert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_put_insert)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, key, val");
    {
	CDB_TinyCDB *	self;
	char *	key = (char *)SvPV_nolen(ST(1))
;
	char *	val = (char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::put_insert() -- self is not a blessed SV reference" )
;
#line 818 "TinyCDB.xs"
        assert_status( self, METHOD_INSERT );
#line 1176 "TinyCDB.c"
#line 820 "TinyCDB.xs"
    {
        RETVAL = cdb_make_put(&self->cdbm, key, strlen(key), val, strlen(val), CDB_PUT_INSERT);
        if ( RETVAL < 0 ) {
            fileerror(self, "update", self->fntemp);
        } else if ( RETVAL > 0) {
            croak("Unable to insert new record - key exists");
        } else {
            RETVAL++;
        }
    }
#line 1188 "TinyCDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_CDB__TinyCDB_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_finish)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	CDB_TinyCDB *	self;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::finish() -- self is not a blessed SV reference" )
;
#line 839 "TinyCDB.xs"
        assert_status( self, METHOD_FINISH );
#line 1219 "TinyCDB.c"
#line 841 "TinyCDB.xs"
    {
        int save_changes = 1;
        int reopen       = 1;
        char *key;
        STRLEN klen;
        int i;

        for ( i = 1; i < items; i += 2 ) {
            key = SvPVx( ST(i), klen);
            if ( strEQ(key, "save_changes") ) {
                save_changes = SvTRUE(ST(i+1)) ? 1 : 0;
            } else if ( strEQ(key, "reopen") ) {
                reopen = SvTRUE(ST(i+1)) ? 1 : 0;
            } else {
                croak("Invalid option %s", key);
            }
        }
        commit( self, save_changes, reopen );
    }
#line 1240 "TinyCDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_CDB__TinyCDB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_CDB__TinyCDB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	CDB_TinyCDB *	self;

    if (
        sv_isobject(ST(0))
            &&
        (SvTYPE(SvRV(ST(0))) == SVt_PVMG)
            &&
        sv_derived_from( ST(0), "CDB::TinyCDB")
    )
        self = (CDB_TinyCDB *)SvIV((SV*)SvRV( ST(0) ));
    else
        croak( "CDB::TinyCDB::DESTROY() -- self is not a blessed SV reference" )
;
#line 865 "TinyCDB.xs"
    {
        commit( self, /* save_changes */ 0, /* reopen */ 0 );
        memfree( self );
        Safefree( self->fn );
        if ( self->fntemp ) {
            Safefree( self->fntemp );
        }
        Safefree( self );
    }
#line 1279 "TinyCDB.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_CDB__TinyCDB); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_CDB__TinyCDB)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        cv = newXSproto_portable("CDB::TinyCDB::load", XS_CDB__TinyCDB_open, file, "$;@");
        XSANY.any_i32 = DOLOAD;
        cv = newXSproto_portable("CDB::TinyCDB::open", XS_CDB__TinyCDB_open, file, "$;@");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("CDB::TinyCDB::create", XS_CDB__TinyCDB_create, file, "$$$");
        (void)newXSproto_portable("CDB::TinyCDB::get", XS_CDB__TinyCDB_get, file, "$$");
        (void)newXSproto_portable("CDB::TinyCDB::exists", XS_CDB__TinyCDB_exists, file, "$$");
        cv = newXSproto_portable("CDB::TinyCDB::getall", XS_CDB__TinyCDB_getall, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("CDB::TinyCDB::getlast", XS_CDB__TinyCDB_getall, file, "$$");
        XSANY.any_i32 = DOGETLAST;
        (void)newXSproto_portable("CDB::TinyCDB::each", XS_CDB__TinyCDB_each, file, "$");
        (void)newXSproto_portable("CDB::TinyCDB::keys", XS_CDB__TinyCDB_keys, file, "$");
        cv = newXSproto_portable("CDB::TinyCDB::put_add", XS_CDB__TinyCDB_put_add, file, "$;@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("CDB::TinyCDB::put_replace", XS_CDB__TinyCDB_put_add, file, "$;@");
        XSANY.any_i32 = CDB_PUT_REPLACE;
        cv = newXSproto_portable("CDB::TinyCDB::put_replace0", XS_CDB__TinyCDB_put_add, file, "$;@");
        XSANY.any_i32 = CDB_PUT_REPLACE0;
        cv = newXSproto_portable("CDB::TinyCDB::put_warn", XS_CDB__TinyCDB_put_add, file, "$;@");
        XSANY.any_i32 = CDB_PUT_WARN;
        (void)newXSproto_portable("CDB::TinyCDB::put_insert", XS_CDB__TinyCDB_put_insert, file, "$$$");
        (void)newXSproto_portable("CDB::TinyCDB::finish", XS_CDB__TinyCDB_finish, file, "$;@");
        (void)newXSproto_portable("CDB::TinyCDB::DESTROY", XS_CDB__TinyCDB_DESTROY, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

